/**
 * Sigma.js WebGL Renderer Arrow Program
 * ======================================
 *
 * Program rendering direction arrows as a simple triangle.
 * @module
 */
import { EdgeDisplayData, NodeDisplayData } from "../../../types";
import { AbstractEdgeProgram, RenderEdgeParams } from "./common/edge";
export default class EdgeArrowHeadProgram extends AbstractEdgeProgram {
    positionLocation: GLint;
    colorLocation: GLint;
    normalLocation: GLint;
    thicknessLocation: GLint;
    radiusLocation: GLint;
    barycentricLocation: GLint;
    matrixLocation: WebGLUniformLocation;
    scaleLocation: WebGLUniformLocation;
    cameraRatioLocation: WebGLUniformLocation;
    viewportRatioLocation: WebGLUniformLocation;
    thicknessRatioLocation: WebGLUniformLocation;
    constructor(gl: WebGLRenderingContext);
    bind(): void;
    computeIndices(): void;
    process(sourceData: NodeDisplayData, targetData: NodeDisplayData, data: EdgeDisplayData, hidden: boolean, offset: number): void;
    render(params: RenderEdgeParams): void;
}
