import { EdgeDisplayData, NodeDisplayData } from "../../../types";
import { AbstractEdgeProgram, RenderEdgeParams } from "./common/edge";
export default class EdgeProgram extends AbstractEdgeProgram {
    IndicesArray: Uint32ArrayConstructor | Uint16ArrayConstructor;
    indicesArray: Uint32Array | Uint16Array;
    indicesBuffer: WebGLBuffer;
    indicesType: GLenum;
    canUse32BitsIndices: boolean;
    positionLocation: GLint;
    colorLocation: GLint;
    normalLocation: GLint;
    thicknessLocation: GLint;
    scaleLocation: WebGLUniformLocation;
    matrixLocation: WebGLUniformLocation;
    cameraRatioLocation: WebGLUniformLocation;
    viewportRatioLocation: WebGLUniformLocation;
    thicknessRatioLocation: WebGLUniformLocation;
    constructor(gl: WebGLRenderingContext);
    bind(): void;
    computeIndices(): void;
    bufferData(): void;
    process(sourceData: NodeDisplayData, targetData: NodeDisplayData, data: EdgeDisplayData, hidden: boolean, offset: number): void;
    render(params: RenderEdgeParams): void;
}
