/**
 * Sigma.js WebGL Renderer Triangle Edge Program
 * ==============================================
 *
 * Program rendering directed edges as a single anti-aliased triangle.
 * @module
 */
import { EdgeDisplayData, NodeDisplayData } from "../../../types";
import { AbstractEdgeProgram, RenderEdgeParams } from "./common/edge";
export default class EdgeTriangleProgram extends AbstractEdgeProgram {
    positionLocation: GLint;
    colorLocation: GLint;
    normalLocation: GLint;
    thicknessLocation: GLint;
    barycentricLocation: GLint;
    matrixLocation: WebGLUniformLocation;
    resolutionLocation: WebGLUniformLocation;
    ratioLocation: WebGLUniformLocation;
    scaleLocation: WebGLUniformLocation;
    constructor(gl: WebGLRenderingContext);
    bind(): void;
    process(sourceData: NodeDisplayData, targetData: NodeDisplayData, data: EdgeDisplayData, hidden: boolean, offset: number): void;
    computeIndices(): void;
    render(params: RenderEdgeParams): void;
}
